app.controller('AnimalsCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    $scope.data = [];
    $scope.counter = 0;
    $scope.title = 'الحيوانات';
    $scope.targetData = [];
    $scope.searchQuery = '';
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.isAr = false;
    $scope.getData = function () {
        
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.counter = 0;
        $scope.targetData = [];
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var deferred = $q.defer();
        db.transaction(function (tx) {

            tx.executeSql('CREATE TABLE IF NOT EXISTS Animals (ID, Name,NameAr,Description,DescriptionAr,MainImage,MainVideo,AnimalTypeName,CurrentDate,AnimalTypeId)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS AnimalImages (ID,AnimalId,ImagePath,Description,DescriptionAr,Details,DetailsAr)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS AnimalVideos (ID,AnimalId,VideoPath,Description,DescriptionAr,Details,DetailsAr)');

            tx.executeSql('SELECT MAX(CurrentDate) MAXDATE FROM Animals', [], function (tx, rs) {
                var parameter = '';
                if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                  parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                  //alert(rs.rows.item(0).MAXDATE);
                }
                else {
                    var parameter = '';
                }
                $http.get('http://ksazoo.com/breeze/mobile/getAnimals' + parameter)
                    .success(function (data) {
                        
                        return $scope.populateData(data);
                        
                    })
                    .error(function (e) {
                        deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.populateData(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        
                        //$scope.$broadcast('scroll.refreshComplete');


                    });
                
            }, function (tx, error) {
                tx.executeSql('DROP TABLE IF EXISTS Animals');
                tx.executeSql('DROP TABLE IF EXISTS AnimalImages');
                tx.executeSql('DROP TABLE IF EXISTS AnimalVideos');
                alert('SELECT error: ' + error.message);
            });
        });
        
        

        
    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Animals';

        } else {
            $scope.isAr = true;
            $scope.title = 'الحيوانات';
        }
    });
    $scope.getData();
    $scope.haveData = false;
    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length > 20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Name: item.Name,
                        NameAr: item.NameAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        MainImage: item.MainImage
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.populateData = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Animals';

        } else {
            $scope.isAr = true;
            $scope.title = 'الحيوانات';
        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {

          //tx.executeSql('SELECT * FROM Animals LIMIT 2', [], function (tx, rs) {
                      
          //  if (rs.rows.length > 0) {
          //    $scope.haveData = true;

          //  }
          //          }, function (tx, error) {
          //            alert('SELECT error: ' + error.message);
          //            $ionicLoading.hide();
          //  });
          //setTimeout(function () {
          //alert($scope.haveData);
          if (data) {
            //alert(data.length);
              data.forEach(function (item) {
                if (item.Status == 1 || item.Status == 0) {
                  tx.executeSql('INSERT INTO Animals VALUES (?,?,?,?,?,?,?,?,?,?)', [item.ID, item.Name,
                    item.NameAr, item.Description, item.DescriptionAr, item.MainImage, item.MainVideo, item.AnimalTypeName, item.CreatedAt, item.AnimalTypeId]);
                  //if ($scope.haveData == true) {
                  //  tx.executeSql('SELECT * FROM Animals where ID = ' + item.ID, [], function (tx, rs) {
                  //    //$ionicLoading.hide();
                  //    if (rs.rows.length > 0) {


                  //    } else {
                  //      tx.executeSql('INSERT INTO Animals VALUES (?,?,?,?,?,?,?,?,?,?)', [item.ID, item.Name,
                  //      item.NameAr, item.Description, item.DescriptionAr, item.MainImage, item.MainVideo, item.AnimalTypeName, item.CreatedAt, item.AnimalTypeId]);

                  //    }
                  //  }, function (tx, error) {
                  //    alert('SELECT error: ' + error.message);
                  //    $ionicLoading.hide();
                  //  });
                  //} else {
                  //  tx.executeSql('INSERT INTO Animals VALUES (?,?,?,?,?,?,?,?,?,?)', [item.ID, item.Name,
                  //  item.NameAr, item.Description, item.DescriptionAr, item.MainImage, item.MainVideo, item.AnimalTypeName, item.CreatedAt, item.AnimalTypeId]);
                  //}

                } else if (item.Status == 2) {
                  tx.executeSql('UPDATE  Animals SET Name=?,NameAr=?,Description=?,DescriptionAr=?,MainImage=?,MainVideo=?,AnimalTypeName=?,CurrentDate=?,AnimalTypeId=? where ID=?', [item.Name,
                  item.NameAr, item.Description, item.DescriptionAr, item.MainImage, item.MainVideo, item.AnimalTypeName, item.CreatedAt, item.AnimalTypeId, item.ID]);
                } else if (item.Status == 3) {
                  tx.executeSql('DELETE FROM  Animals where ID=?', [item.ID]);
                }
                item.animalImages.forEach(function (image) {
                  if (image.Status == 1) {
                    tx.executeSql('INSERT INTO AnimalImages VALUES (?,?,?,?,?,?,?)', [image.ID, item.ID, image.ImagePath,
                    image.Description, image.DescriptionAr,
                    image.Details, image.DetailsAr]);
                  } else if (image.Status == 2) {
                    tx.executeSql('UPDATE  AnimalImages SET ImagePath=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=? where ID=?', [image.ImagePath,
                    image.Description, image.DescriptionAr,
                    image.Details, image.DetailsAr, image.ID]);
                  } else if (image.Status == 3) {
                    tx.executeSql('DELETE FROM  AnimalImages where ID=?', [image.ID]);
                  }

                });
                item.animalVideos.forEach(function (video) {
                  if (video.Status == 1) {
                    tx.executeSql('INSERT INTO AnimalVideos VALUES (?,?,?,?,?,?,?)', [video.ID, item.ID, video.VideoPath,
                    video.Description, video.DescriptionAr,
                    video.Details, video.DetailsAr]);
                  } else if (video.Status == 2) {
                    tx.executeSql('UPDATE AnimalVideos SET VideoPath=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=? where ID=?', [video.VideoPath,
                    video.Description, video.DescriptionAr,
                    video.Details, video.DetailsAr, video.ID]);

                  } else if (video.Status == 3) {
                    tx.executeSql('DELETE FROM  AnimalVideos where ID=?', [video.ID]);
                  }
                });
              });
            }
            tx.executeSql('SELECT * FROM Animals order by ID DESC', [], function (tx, rs) {
              for (var i = 0; i < rs.rows.length; i++) {
                $scope.data.push({
                  RowId: i + 1,
                  ID: rs.rows.item(i).ID,
                  Name: rs.rows.item(i).Name,
                  NameAr: rs.rows.item(i).NameAr,
                  Description: rs.rows.item(i).Description,
                  DescriptionAr: rs.rows.item(i).DescriptionAr,
                  MainImage: rs.rows.item(i).MainImage
                });

              }
              $scope.data.forEach(function (item) {
                if (item.RowId <= 10) {
                  $scope.targetData.push({
                    RowId: item.RowId,
                    ID: item.ID,
                    Name: item.Name,
                    NameAr: item.NameAr,
                    Description: item.Description,
                    DescriptionAr: item.DescriptionAr,
                    MainImage: item.MainImage
                  });
                }
              });
              $scope.counter += 10;
            });
          //},100)
            
            


        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS Animals');
                tx.executeSql('DROP TABLE IF EXISTS AnimalImages');
                tx.executeSql('DROP TABLE IF EXISTS AnimalVideos');
                alert('Transaction ERROR: ' + error.message);
            });
            $ionicLoading.hide();
            alert('Transaction ERROR: ' + error.message);
        }, function () {
            $ionicLoading.hide();
            //alert('Populated database OK');

        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

    
    
    
});
