app.controller('AnimalsDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite, $ionicBackdrop, $ionicModal, $ionicSlideBoxDelegate, $ionicScrollDelegate) {
    //ionic.material.ink.displayEffect();
    $scope.data = null;
    $scope.images = [];
    $scope.videos = [];
    $scope.isAr = false;
    $scope.closeSlider = '';
    $scope.animalName='';
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.closeSlider = 'Please Sqap Down To Close the Sliders Gallery';
        } else {
            $scope.isAr = true;
            $scope.closeSlider = 'من فضلك اسحب للاسفل لتغلق الصور';
        }
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        }
    });
    $scope.getData = function (Id) {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        var deferred = $q.defer()

        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM Animals where ID = '+Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    $scope.data = {
                        ID: rs.rows.item(0).ID,
                        Name: rs.rows.item(0).Name,
                        NameAr: rs.rows.item(0).NameAr,
                        Description: rs.rows.item(0).Description,
                        DescriptionAr: rs.rows.item(0).DescriptionAr,
                        MainImage: rs.rows.item(0).MainImage,
                        MainVideo: rs.rows.item(0).MainVideo,
                        AnimalTypeName: rs.rows.item(0).AnimalTypeName
                  };
                    if ($scope.isAr == true) {
                      $scope.animalName = $scope.data.NameAr;
                    } else {
                      $scope.animalName = $scope.data.Name;
                    }
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
            tx.executeSql('SELECT * FROM AnimalImages where AnimalId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.images.push({
                            ID: rs.rows.item(i).ID,
                            ImagePath: rs.rows.item(i).ImagePath,
                            Description: rs.rows.item(i).Description,
                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                            Details: rs.rows.item(i).Details,
                            DetailsAr: rs.rows.item(i).DetailsAr
                        });
                    }
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
            tx.executeSql('SELECT * FROM AnimalVideos where AnimalId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.videos.push({
                            ID: rs.rows.item(i).ID,
                            VideoPath: rs.rows.item(i).VideoPath,
                            Description: rs.rows.item(i).Description,
                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                            Details: rs.rows.item(i).Details,
                            DetailsAr: rs.rows.item(i).DetailsAr
                        });
                    }
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        //$http.get('http://ksazoo.com/breeze/mobile/getAnimalDetails?Id=' + Id)
        //.success(function (data) {
        //    deferred.resolve(data);
        //    $scope.data = data;
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //})
        //.error(function (e) {
        //    deferred.reject();
        //    console.log('error');
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //});
        //$scope.data = deferred.promise;
    };
    
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };


    //$scope.options = {
    //    loop: false,
    //    effect: 'fade',
    //    speed: 500,
    //}

    //$scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
    //    // data.slider is the instance of Swiper
    //    $scope.slider = data.slider;
    //});

    //$scope.$on("$ionicSlides.slideChangeStart", function (event, data) {
    //    console.log('Slide change is beginning');
    //});

    //$scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
    //    // note: the indexes are 0-based
    //    $scope.activeIndex = data.slider.activeIndex;
    //    $scope.previousIndex = data.slider.previousIndex;
    //});

    

    $scope.zoomMin = 2;


    $scope.showImages = function (index) {
        $scope.activeSlide = index;
        $scope.showModal('templates/gallery-zoomview.html');
    };

    $scope.showModal = function (templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
        });
    }

    $scope.closeModal = function () {
        $scope.modal.hide();
        $scope.modal.remove()
    };

    $scope.updateSlideStatus = function (slide) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor == $scope.zoomMin) {
            $ionicSlideBoxDelegate.enableSlide(true);
        } else {
            $ionicSlideBoxDelegate.enableSlide(false);
        }
    };
    $scope.slideChanged = function () {
        alert('test');
    }
});
