app.controller('CompetitionsCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.isAr = false;
    $scope.Competitions = '';
    $scope.targetData = [];
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.getData = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        //var x2js = new X2JS();

        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS Competation (ID, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,StartDate,EndDate,CurrentDate)');
            tx.executeSql('SELECT MAX(ID) ,CurrentDate as  MAXDATE FROM Competation group by CurrentDate', [], function (tx, rs) {
                var parameter = '';
                if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                    parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;

                }
                else {
                    var parameter = '';
                }
                $http.get('http://ksazoo.com/breeze/mobile/GetCompetitions' + parameter)
                    .success(function (data) {
                        //$scope.data = data;
                        
                        $scope.populateDate(data);
                        //deferred.resolve(data);
                        // $scope.data = data;
                        $ionicLoading.hide();
                        //$scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        $scope.populateDate(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        //$scope.$broadcast('scroll.refreshComplete');

                    });

               
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                tx.executeSql('DROP TABLE IF EXISTS Competation');
            });
        });

    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.getData();
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/ionic.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Competitions = 'Competitions';
        } else {
            $scope.isAr = true;
            $scope.Competitions = 'المسابقات';
        }
    });
    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length > 20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Name: item.Name,
                        NameAr: item.NameAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        Details: item.Details,
                        DetailsAr: item.DetailsAr,
                        MainImage: item.MainImage,
                        StartDate: item.StartDate,
                        EndDate: item.EndDate,
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.populateDate = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Competitions = 'Competitions';
        } else {
            $scope.isAr = true;
            $scope.Competitions = 'المسابقات';
        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }

        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO Competation VALUES (?,?,?,?,?,?,?,?,?,?,?)',
                         [item.ID, item.Name, item.NameAr,
                             item.Description, item.DescriptionAr,
                             item.Details, item.DetailsAr, item.MainImage, item.StartDate,
                             item.EndDate, item.CurrentDate]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE Competation SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage?=,StartDate=?,EndDate=?,CurrentDate=? WHERE ID=?',
                         [item.Name, item.NameAr,
                             item.Description, item.DescriptionAr,
                             item.Details, item.DetailsAr, item.MainImage, item.StartDate,
                             item.EndDate, item.CurrentDate, item.ID]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  Competation where ID=?', [item.ID]);
                    }
                });
            }

            tx.executeSql('SELECT * FROM Competation order by ID DESC', [], function (tx, rs) {
                for (var i = 0; i < rs.rows.length; i++) {
                    $scope.data.push({
                        RowId: i + 1,
                        ID: rs.rows.item(i).ID,
                        Name: rs.rows.item(i).Name,
                        NameAr: rs.rows.item(i).NameAr,
                        Description: rs.rows.item(i).Description,
                        DescriptionAr: rs.rows.item(i).DescriptionAr,
                        Details: rs.rows.item(i).Details,
                        DetailsAr: rs.rows.item(i).DetailsAr,
                        MainImage: rs.rows.item(i).MainImage,
                        StartDate: rs.rows.item(i).StartDate,
                        EndDate: rs.rows.item(i).EndDate,
                    });

                }
                $scope.data.forEach(function (item) {
                    if (item.RowId <= 20) {
                        $scope.targetData.push({
                            RowId: item.RowId,
                            ID: item.ID,
                            Name: item.Name,
                            NameAr: item.NameAr,
                            Description: item.Description,
                            DescriptionAr: item.DescriptionAr,
                            Details: item.Details,
                            DetailsAr: item.DetailsAr,
                            MainImage: item.MainImage,
                            StartDate: item.StartDate,
                            EndDate: item.EndDate,
                        });
                    }
                });
                $scope.counter += 20;
            });
        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS Competation');
                alert('Transaction ERROR: ' + error.message);
            });
        }, function () {
            //alert('Populated database OK');

        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

});
