﻿app.controller('ServiceCategoryCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.counter = 0;
    $scope.targetData = [];
    $scope.isAr = false;
    $scope.title = '';
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    var reset = function () {
        var inClass = document.querySelectorAll('.in');
        for (var i = 0; i < inClass.length; i++) {
            inClass[i].classList.remove('in');
            inClass[i].removeAttribute('style');
        }
        var done = document.querySelectorAll('.done');
        for (var i = 0; i < done.length; i++) {
            done[i].classList.remove('done');
            done[i].removeAttribute('style');
        }
        var ionList = document.getElementsByTagName('ion-list');
        for (var i = 0; i < ionList.length; i++) {
            var toRemove = ionList[i].className;
            if (/animate-/.test(toRemove)) {
                ionList[i].className = ionList[i].className.replace(/(?:^|\s)animate-\S*(?:$|\s)/, '');
            }
        }
    };

    $scope.ripple = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-ripple';
        setTimeout(function () {
            ionicMaterialMotion.ripple();
        }, 500);
    };

    $scope.fadeSlideInRight = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in-right';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideInRight();
        }, 500);
    };

    $scope.fadeSlideIn = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideIn();
        }, 500);
    };

    $scope.blinds = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-blinds';
        setTimeout(function () {
            ionicMaterialMotion.blinds(); // ionic.material.motion.blinds(); //ionicMaterialMotion
        }, 500);
    };
    //$scope.$on('$ionicView.enter', function () {
    //    // code to run each time view is entered
    //    $scope.getData();

    //});
    
    $scope.getData = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.counter = 0;
        $scope.targetData = [];
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        //var x2js = new X2JS();
        
        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS ServicesCategory (ID, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CreatedAt,ModifiedAt,CurrentDate)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS Services (ID,ServiceCategoryId, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,Map,CreatedAt,ModifiedAt)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS Menus (ID,ServiceId, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CreatedAt,ModifiedAt)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS MenuItems (ID,MenuId, Title,TitleAr,Description,DescriptionAr,Details,DetailsAr,MainImage,Price,CreatedAt,ModifiedAt)');
            tx.executeSql('SELECT MAX(CurrentDate) as MAXDATE FROM ServicesCategory', [], function (tx, rs) {
                var parameter = '';
                if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                    parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                }
                else {
                    var parameter = '';
                }
                $http.get('http://ksazoo.com/breeze/mobile/getServicesCategory' + parameter)
                    .success(function (data) {
                       // $scope.data = data;
                        $scope.populateData(data);

                        //deferred.resolve(data);
                        // $scope.data = data;
                        
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        $scope.populateData(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        console.log('error');
                        $ionicLoading.hide();

                    });
                
            }, function (tx, error) {
                tx.executeSql('DROP TABLE IF EXISTS ServicesCategory');
                tx.executeSql('DROP TABLE IF EXISTS Services');
                tx.executeSql('DROP TABLE IF EXISTS Menus');
                tx.executeSql('DROP TABLE IF EXISTS MenuItems');
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        
    };
    $scope.getData();
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    //$scope.getData();
    
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return  'http://ksazoo.com/Uploads/'+i;
        } else {
            return 'img/no_image.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Services';
        } else {
            $scope.isAr = true;
            $scope.title = 'الخدمات';
        }
        
            //$scope.getData();
        
    });
    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length > 20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Name: item.Name,
                        NameAr: item.NameAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        Details: item.Details,
                        DetailsAr: item.DetailsAr,
                        MainImage: item.MainImage
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.populateData = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Services';
        } else {
            $scope.isAr = true;
            $scope.title = 'الخدمات';
        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO ServicesCategory VALUES (?,?,?,?,?,?,?,?,?,?,?)',
                     [item.ID, item.Name, item.NameAr,
                         item.Description, item.DescriptionAr,
                         item.Details, item.DetailsAr, item.MainImage,
                         item.CreatedAt, item.ModifiedAt, item.CurrentDate]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE ServicesCategory SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CreatedAt=?,ModifiedAt=?,CurrentDate=? WHERE ID=?',
                     [item.Name, item.NameAr,
                         item.Description, item.DescriptionAr,
                         item.Details, item.DetailsAr, item.MainImage,
                         item.CreatedAt, item.ModifiedAt, item.CurrentDate, item.ID]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  ServicesCategory where ID=?', [item.ID]);
                    }

                    item.services.forEach(function (service) {
                        if (service.Status == 1 || service.Status == 0) {
                            tx.executeSql('INSERT INTO Services VALUES (?,?,?,?,?,?,?,?,?,?,?,?)',
                        [service.ID, service.ServiceCategoryId, service.Name, service.NameAr,
                            service.Description, service.DescriptionAr,
                            service.Details, service.DetailsAr, service.MainImage, service.Map,
                            service.CreatedAt, service.ModifiedAt]);
                        } else if (service.Status == 2) {
                            tx.executeSql('UPDATE Services SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,Map=?,CreatedAt=?,ModifiedAt=? WHERE ID=?',
                        [service.Name, service.NameAr,
                            service.Description, service.DescriptionAr,
                            service.Details, service.DetailsAr, service.MainImage, service.Map,
                            service.CreatedAt, service.ModifiedAt, service.ID]);
                        } else if (service.Status == 3) {
                            tx.executeSql('DELETE FROM  Services where ID=?', [service.ID]);
                        }

                        service.Menus.forEach(function (menu) {
                            if (menu.Status == 1 || menu.Status == 0) {
                                tx.executeSql('INSERT INTO Menus VALUES (?,?,?,?,?,?,?,?,?,?,?)',
                                [menu.ID, menu.ServiceId, menu.Name, menu.NameAr,
                                    menu.Description, menu.DescriptionAr,
                                    menu.Details, menu.DetailsAr, menu.Image,
                                    menu.CreatedAt, menu.ModifiedAt]);
                            } else if (menu.Status == 2) {
                                tx.executeSql('UPDATE Menus SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CreatedAt=?,ModifiedAt=? where ID=?',
                                [menu.Name, menu.NameAr,
                                    menu.Description, menu.DescriptionAr,
                                    menu.Details, menu.DetailsAr, menu.Image,
                                    menu.CreatedAt, menu.ModifiedAt, menu.ID]);
                            } else if (menu.Status == 3) {
                                tx.executeSql('DELETE FROM  Menus where ID=?', [menu.ID]);
                            }

                            menu.MenuItems.forEach(function (menuItem) {
                                if (menuItem.Status == 1 || menuItem.Status == 0) {
                                    tx.executeSql('INSERT INTO MenuItems VALUES (?,?,?,?,?,?,?,?,?,?,?,?)',
                                        [menuItem.ID, menuItem.MenuId, menuItem.Title, menuItem.TitleAr,
                                            menuItem.Description, menuItem.DescriptionAr,
                                            menuItem.Details, menuItem.DetailsAr, menuItem.ItemImage, menuItem.Price,
                                            menuItem.CreatedAt, menuItem.ModifiedAt]);
                                } else if (menuItem.Status == 2) {
                                    tx.executeSql('UPDATE MenuItems SET Title=?,TitleAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,Price=?,CreatedAt=?,ModifiedAt=? WHERE ID=?',
                                        [menuItem.Title, menuItem.TitleAr,
                                            menuItem.Description, menuItem.DescriptionAr,
                                            menuItem.Details, menuItem.DetailsAr, menuItem.ItemImage, menuItem.Price,
                                            menuItem.CreatedAt, menuItem.ModifiedAt, menuItem.ID]);

                                } else if (menuItem.Status == 3) {
                                    tx.executeSql('DELETE FROM  MenuItems where ID=?', [menuItem.ID]);
                                }



                            });
                        });

                    });
                });
            }
            tx.executeSql('SELECT * FROM ServicesCategory order by ID DESC', [], function (tx, rs) {
                for (var i = 0; i < rs.rows.length; i++) {
                    $scope.data.push({
                        RowId: i + 1,
                        ID: rs.rows.item(i).ID,
                        Name: rs.rows.item(i).Name,
                        NameAr: rs.rows.item(i).NameAr,
                        Description: rs.rows.item(i).Description,
                        DescriptionAr: rs.rows.item(i).DescriptionAr,
                        Details: rs.rows.item(i).Details,
                        DetailsAr: rs.rows.item(i).DetailsAr,
                        MainImage: rs.rows.item(i).MainImage
                    });
                }
                $scope.data.forEach(function (item) {
                    if (item.RowId <= 20) {
                        $scope.targetData.push({
                            RowId: item.RowId,
                            ID: item.ID,
                            Name: item.Name,
                            NameAr: item.NameAr,
                            Description: item.Description,
                            DescriptionAr: item.DescriptionAr,
                            Details: item.Details,
                            DetailsAr: item.DetailsAr,
                            MainImage: item.MainImage
                        });
                    }
                });
                $scope.counter += 20;
            });
            $ionicLoading.hide();

        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS ServicesCategory');
                tx.executeSql('DROP TABLE IF EXISTS Services');
                tx.executeSql('DROP TABLE IF EXISTS Menus');
                tx.executeSql('DROP TABLE IF EXISTS MenuItems');
                alert('Transaction ERROR: ' + error.message);
                $ionicLoading.hide();
            });
        }, function () {
            //alert('Populated database OK');
            $ionicLoading.hide();
            $ionicLoading.hide();
        });
    };

    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
});