﻿app.controller('ServicesCtrl', function ($scope, $stateParams, ionicMaterialInk, $http, $q, $ionicLoading, $cordovaSQLite, ionicMaterialMotion) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.title = '';
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    var reset = function () {
        var inClass = document.querySelectorAll('.in');
        for (var i = 0; i < inClass.length; i++) {
            inClass[i].classList.remove('in');
            inClass[i].removeAttribute('style');
        }
        var done = document.querySelectorAll('.done');
        for (var i = 0; i < done.length; i++) {
            done[i].classList.remove('done');
            done[i].removeAttribute('style');
        }
        var ionList = document.getElementsByTagName('ion-list');
        for (var i = 0; i < ionList.length; i++) {
            var toRemove = ionList[i].className;
            if (/animate-/.test(toRemove)) {
                ionList[i].className = ionList[i].className.replace(/(?:^|\s)animate-\S*(?:$|\s)/, '');
            }
        }
    };

    $scope.ripple = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-ripple';
        setTimeout(function () {
            ionicMaterialMotion.ripple();
        }, 500);
    };

    $scope.fadeSlideInRight = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in-right';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideInRight();
        }, 500);
    };

    $scope.fadeSlideIn = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideIn();
        }, 500);
    };

    $scope.blinds = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-blinds';
        setTimeout(function () {
            ionicMaterialMotion.blinds(); // ionic.material.motion.blinds(); //ionicMaterialMotion
        }, 500);
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Services';
        } else {
            $scope.isAr = true;
            $scope.title = 'الخدمات';
        }
        
    });
    //if ($stateParams.ID) {
        
    //}
    $scope.getData = function (Id) {
        //$ionicLoading.show({
        //    template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        //});
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM Services where ServiceCategoryId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.data.push({
                            ID: rs.rows.item(i).ID,
                            Name: rs.rows.item(i).Name,
                            NameAr: rs.rows.item(i).NameAr,
                            Description: rs.rows.item(i).Description,
                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                            Details: rs.rows.item(i).Details,
                            DetailsAr: rs.rows.item(i).DetailsAr,
                            MainImage: rs.rows.item(i).MainImage,
                            Map: rs.rows.item(i).Map
                        });
                    }
                    $ionicLoading.hide();
                } else {
                    var deferred = $q.defer()
                    $http.get('http://ksazoo.com/breeze/mobile/getServices?categoryId=' + Id)
                    .success(function (data) {
                        deferred.resolve(data);
                        $scope.data = data;
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function (e) {
                        deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });
                    $scope.data = deferred.promise;
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        
        $scope.blinds();
    };
    $scope.getData($stateParams.ID)
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return 'http://ksazoo.com/Uploads/thumbs1/'+i;
        } else {
            return 'img/no_image.png'
        }
    };
    
});