﻿app.controller('VideoImagesDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $http, $q, $ionicLoading, $cordovaSQLite, ionicMaterialMotion, $sce, $ionicBackdrop, $ionicModal, $ionicSlideBoxDelegate, $ionicScrollDelegate) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.title = '';
    $scope.closeSlider = '';
    $scope.images = [];
    $scope.videos = [];
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    var reset = function () {
        var inClass = document.querySelectorAll('.in');
        for (var i = 0; i < inClass.length; i++) {
            inClass[i].classList.remove('in');
            inClass[i].removeAttribute('style');
        }
        var done = document.querySelectorAll('.done');
        for (var i = 0; i < done.length; i++) {
            done[i].classList.remove('done');
            done[i].removeAttribute('style');
        }
        var ionList = document.getElementsByTagName('ion-list');
        for (var i = 0; i < ionList.length; i++) {
            var toRemove = ionList[i].className;
            if (/animate-/.test(toRemove)) {
                ionList[i].className = ionList[i].className.replace(/(?:^|\s)animate-\S*(?:$|\s)/, '');
            }
        }
    };

    $scope.ripple = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-ripple';
        setTimeout(function () {
            ionicMaterialMotion.ripple();
        }, 500);
    };

    $scope.fadeSlideInRight = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in-right';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideInRight();
        }, 500);
    };

    $scope.fadeSlideIn = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-fade-slide-in';
        setTimeout(function () {
            ionicMaterialMotion.fadeSlideIn();
        }, 500);
    };

    $scope.blinds = function () {
        reset();
        document.getElementsByTagName('ion-list')[0].className += ' animate-blinds';
        setTimeout(function () {
            ionicMaterialMotion.blinds(); // ionic.material.motion.blinds(); //ionicMaterialMotion
        }, 500);
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Gallery & Videos';
        } else {
            $scope.isAr = true;
            $scope.title = 'معرض الصور و الفيديو';
            
        }
        //if ($stateParams.ID) {
        //    $scope.getData($stateParams.ID)
        //}
    });
    $scope.getData = function (Id) {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM GalleryDetails where GalleryId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        if (rs.rows.item(i).TypeId == '1') {
                            $scope.images.push({
                                ID: rs.rows.item(i).ID,
                                FileUploaded: rs.rows.item(i).FileUploaded,
                            });
                        } else {
                            $scope.videos.push({
                                ID: rs.rows.item(i).ID,
                                FileUploaded: rs.rows.item(i).FileUploaded,
                            });
                        }

                    }
                    $ionicLoading.hide();
                } else {
                    
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });

        $scope.blinds();
    };
    $scope.getData($stateParams.ID);
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };

    //gallery
    $scope.zoomMin = 2;


    $scope.showImages = function (index) {
        $scope.activeSlide = index;
        $scope.showModal('templates/gallery-zoomview.html');
    };

    $scope.showModal = function (templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
        });
    }

    $scope.closeModal = function () {
        $scope.modal.hide();
        $scope.modal.remove()
    };

    $scope.updateSlideStatus = function (slide) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor == $scope.zoomMin) {
            $ionicSlideBoxDelegate.enableSlide(true);
        } else {
            $ionicSlideBoxDelegate.enableSlide(false);
        }
    };
    $scope.trustedHtml = function (item) {
        return $sce.trustAsHtml(item)
    };
});