﻿app.controller('VideosImagesCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.title = '';
    $scope.counter = 0;
    $scope.targetData = [];
    $scope.isAr = false;
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.getData = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        //var x2js = new X2JS();

        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS Gallery (ID, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CurrentDate)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS GalleryDetails (ID,GalleryId, TypeId,FileUploaded,TypeName,TypeNameAr)');
            tx.executeSql('SELECT MAX(CurrentDate) as MAXDATE FROM Gallery', [], function (tx, rs) {
                var parameter = '';
                if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                    parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                    
                }
                else {
                    var parameter = '';
                }

                $http.get('http://ksazoo.com/breeze/mobile/GetGallery' + parameter)
                    .success(function (data) {
                        //$scope.data = data;
                        $scope.populateData(data);

                        //deferred.resolve(data);
                        // $scope.data = data;
                        //$ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        $scope.populateData(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });

            }, function (tx, error) {
                tx.executeSql('DROP TABLE IF EXISTS Gallery');
                tx.executeSql('DROP TABLE IF EXISTS GalleryDetails');
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });

    };
    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length >20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Name: item.Name,
                        NameAr: item.NameAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        Details: item.Details,
                        DetailsAr: item.DetailsAr,
                        MainImage: item.MainImage
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.getData();
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Gallery';
        } else {
            $scope.isAr = true;
            $scope.title = ' معرض الصور و الفيديوهات';
            
        }
    });
    $scope.populateData = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Gallery';
        } else {
            $scope.isAr = true;
            $scope.title = ' معرض الصور و الفيديوهات';

        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO Gallery VALUES (?,?,?,?,?,?,?,?,?)',
                             [item.ID, item.Name, item.NameAr,
                                 item.Description, item.DescriptionAr,
                                 item.Details, item.DetailsAr, item.MainImage, item.CurrentDate]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE Gallery SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CurrentDate=? WHERE ID=?',
                             [item.Name, item.NameAr,
                                 item.Description, item.DescriptionAr,
                                 item.Details, item.DetailsAr, item.MainImage, item.CurrentDate, item.ID]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  Gallery where ID=?', [item.ID]);
                    }

                    item.GalleryItems.forEach(function (q) {
                        if (q.Status == 1 || q.Status == 0) {
                            tx.executeSql('INSERT INTO GalleryDetails  VALUES (?,?,?,?,?,?)',
                        [q.ID, item.ID, q.TypeId, q.FileUploaded, q.TypeName, q.TypeNameAr]);
                        } else if (q.Status == 2) {
                            tx.executeSql('UPDATE GalleryDetails  SET FileUploaded=?,TypeName=?,TypeNameAr=? WHERE ID=? ',
                        [q.FileUploaded, q.TypeName, q.TypeNameAr, q.ID]);
                        } else if (q.Status == 3) {
                            tx.executeSql('DELETE FROM  GalleryDetails where ID=?', [item.ID]);
                        }



                    });
                });
            }

            tx.executeSql('SELECT * FROM Gallery order by ID DESC', [], function (tx, rs) {
                for (var i = 0; i < rs.rows.length; i++) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.data.push({
                            RowId: i + 1,
                            ID: rs.rows.item(i).ID,
                            Name: rs.rows.item(i).Name,
                            NameAr: rs.rows.item(i).NameAr,
                            Description: rs.rows.item(i).Description,
                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                            Details: rs.rows.item(i).Details,
                            DetailsAr: rs.rows.item(i).DetailsAr,
                            MainImage: rs.rows.item(i).MainImage
                        });
                    }

                }
                $scope.data.forEach(function (item) {
                    if (item.RowId <= 20) {
                        $scope.targetData.push({
                            RowId: item.RowId,
                            ID: item.ID,
                            Name: item.Name,
                            NameAr: item.NameAr,
                            Description: item.Description,
                            DescriptionAr: item.DescriptionAr,
                            Details: item.Details,
                            DetailsAr: item.DetailsAr,
                            MainImage: item.MainImage
                        });
                    }
                });
                $scope.counter += 20;
            });
            $ionicLoading.hide();

        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS Gallery');
                tx.executeSql('DROP TABLE IF EXISTS GalleryDetails');
                alert('Transaction ERROR: ' + error.message);
                $ionicLoading.hide();
            });
        }, function () {
            //alert('Populated database OK');
            $ionicLoading.hide();
        });
    };

    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
});