﻿app.controller('VistortypeCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.isAr = false;
    $scope.Title = '';
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.getData = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        //var x2js = new X2JS();

        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS VistorType (ID, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CreatedAt,ModifiedAt,CurrentDate)');
            //tx.executeSql('CREATE TABLE IF NOT EXISTS Vistor (ID,VistorTypeId, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CreatedAt,ModifiedAt)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS VistorDay (ID,VistorTypeId, Name,NameAr,Title,TitleAr,Description,DescriptionAr,TimeFrom,TimeTo)');

            tx.executeSql('SELECT MAX(CurrentDate) as MAXDATE FROM VistorType', [], function (tx, rs) {
                var parameter = '';
                if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                    parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                }
                else {
                    var parameter = '';
                }
                $http.get('http://ksazoo.com/breeze/mobile/GetVisitorTypes' + parameter)
                    .success(function (data) {
                        //$scope.data = data;
                        $scope.populateData(data);
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        $scope.populateData(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });
                
            }, function (tx, error) {
                tx.executeSql('DROP TABLE IF EXISTS VistorType');
                tx.executeSql('DROP TABLE IF EXISTS VistorDay');
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });

    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.getData();
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png';
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'Vistors';
        } else {
            $scope.isAr = true;
            $scope.Title = 'الزوار';
        }
    });
    $scope.populateData = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'Vistors';
        } else {
            $scope.isAr = true;
            $scope.Title = 'الزوار';
        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO VistorType VALUES (?,?,?,?,?,?,?,?,?,?,?)',
                             [item.ID, item.Name, item.NameAr,
                                 item.Description, item.DescriptionAr,
                                 item.Details, item.DetailsAr, item.MainImage,
                                 item.CreatedAt, item.ModifiedAt, item.CurrentDate,
                             ]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE VistorType SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CreatedAt=?,ModifiedAt=?,CurrentDate=? where ID=?',
                     [item.Name, item.NameAr,
                         item.Description, item.DescriptionAr,
                         item.Details, item.DetailsAr, item.MainImage,
                         item.CreatedAt, item.ModifiedAt, item.CurrentDate, item.ID]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  VistorType where ID=?', [item.ID]);
                    }

                    item.VisitorDays.forEach(function (service) {
                        if (service.Status == 1 || service.Status == 0) {
                            tx.executeSql('INSERT INTO VistorDay VALUES (?,?,?,?,?,?,?,?,?,?)',
                        [service.ID, service.VistoerTypeId, service.Name, service.NameAr,
                        service.Title, service.TitleAr, service.Description, service.DescriptionAr,
                        service.TimeFrom, service.TimeTo]);
                        } else if (service.Status == 2) {
                            tx.executeSql('UPDATE VistorDay SET Name=?,NameAr=?,Title=?,TitleAr=?,Description=?,DescriptionAr=?,TimeFrom=?,TimeTo=? where ID=?',
                        [service.Name, service.NameAr, service.Title, service.TitleAr, service.Description, service.DescriptionAr,
                        service.TimeFrom, service.TimeTo, service.ID]);
                        } else if (service.Status == 3) {
                            tx.executeSql('DELETE FROM  VistorDay where ID=?', [service.ID]);
                        }

                    });
                });
            }
            tx.executeSql('SELECT * FROM VistorType order by ID DESC', [], function (tx, rs) {
                for (var i = 0; i < rs.rows.length; i++) {
                    $scope.data.push({
                        ID: rs.rows.item(i).ID,
                        Name: rs.rows.item(i).Name,
                        NameAr: rs.rows.item(i).NameAr,
                        Description: rs.rows.item(i).Description,
                        DescriptionAr: rs.rows.item(i).DescriptionAr,
                        Details: rs.rows.item(i).Details,
                        DetailsAr: rs.rows.item(i).DetailsAr,
                        MainImage: rs.rows.item(i).MainImage,
                    });
                }
            });
            $ionicLoading.hide();

        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS VistorType');
                tx.executeSql('DROP TABLE IF EXISTS VistorDay');
                alert('Transaction ERROR: ' + error.message);
                $ionicLoading.hide();
            });
        }, function () {
            //alert('Populated database OK');
            $ionicLoading.hide();

        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

});